// C Header File
// Created 06/09/2001; 17:15:35


void calcul_totaux(int *score)
{
	
	size_t i;
	int total=0;
	
	for(i=0;i<ptTOTAL;i++)
		if(score[i]!=-1)
			total+=score[i];
			
	score[ptTOTAL]=total;
	
	if(total>=60) /* Avec un petit total >=60 on obtiens un bonus de la mme valeur */
		score[BONUS]=total;
		
	total=0;

	for(i=BRELAN;i<=CHANCE;i++)
		if(score[i]!=-1)
			total+=score[i];
			
	score[TOTAL]=score[ptTOTAL]+score[BONUS]+total;
	
}

long cmpfunc(const void *a, const void *b)
{
  return *(short*)a - *(short*)b ;   // Note that typecasts are necessary
}


int calcul_points(short *des, short coup)
{
	
	size_t i;
	int total=0;
	
	qsort(des, 5, sizeof (short), cmpfunc); /* classe les ds par ordre croissant */
	
	switch (coup)
	{
		
		case 0 ... 5:
		
			/* Il suffit de compter les occurences du ds reprsent par coup */
			
			for(i=0;i<5;i++)
			{
			
				if(des[i]==coup+1)
					total+=coup+1;
				
			}	
		
			return total;
			break;
			
		case BRELAN:
		
			/* Maintenant que les ds sont classs, il suffit de tester si :
				- Le premier ds est le mme que le troisime
				- ou le deuxime gal au quatrime
				- ou le troisime gal au cinquime */
				
			if(des[0]==des[2] || des[1]==des[3] || des[2]==des[4])
				 /* Un brelan = la valeur du ds en brelan fois 3 (le ds du milieu est forcment dans le brelan */
				return 3*des[2]; 
		
			else return 0;		
	
		case FULL:
		
			/* Mme technique que pour le brelan */
			
			if((des[0]==des[2] && des[3]==des[4]) || (des[0]=des[1] && des[2]==des[4]))
				return VALEUR_FULL;
			else return 0;	
			
		case CARRE:
		
			/* Mme technique que pour le brelan */
			
			if(des[0]==des[3] || des[1]==des[4])
				return VALEUR_CARRE;
			else return 0;
			
		case 	PtSUITE:
		{
			
			short nbdes[7]={0,0,0,0,0,0,0}; /* compte chaque valeur de ds ( la premire valeur nbdes[0] est inutilise ) */
			
			/* Voici les suites possibles ( X remplace un ds quelquonque )
			
				1234X
				 2345X
				  3456X
			
			*/
			
			for(i=0;i<5;i++)
				nbdes[des[i]]++;
				
			/* Les valeurs 3 et 4 sont forcment dans la petite suite */	
			
			if(!nbdes[3] || !nbdes[4] ) /* si l'un des deux est nul : */
				return 0;
				
			/* 1er cas : 1234X */
			if(nbdes[1] && nbdes[2]) /* si il y a au moins un des dans chaque : */
				return VALEUR_PtSUITE;
				
			/* 2me cas : 2345X */	
			else if(nbdes[2] && nbdes[5])
				return VALEUR_PtSUITE;
				
			/* 3me cas : 3456X */	
			else if(nbdes[5] && nbdes[6])
				return VALEUR_PtSUITE;	
				
			return 0; /* Pas de petite suite */	
			
		}
		
		case GdSUITE:
		{
			
			short nbdes[7]={0,0,0,0,0,0,0}; /* compte chaque valeur de ds ( la premire valeur nbdes[0] est inutilise ) */
			
			/* Voici les suites possibles ( X remplace un ds quelquonque )
			
				12345
				 23456
			
			*/
			
			for(i=0;i<5;i++)
				nbdes[des[i]]++;
			
			
			/* Les valeurs 2, 3, 4 et 5 sont forcment dans la petite suite */	
			
			if(!nbdes[2] || !nbdes[3] || !nbdes[4] || !nbdes[5]) /* si l'un des quatre est nul : */
				return 0;
				
			if(nbdes[1] || nbdes[6])
				return VALEUR_GdSUITE;
				
			return 0; /* Pas de grande suite */
			break;
			
		}
		
		case YAM:
		
			/* Mme technique que pour le brelan */
			
			if(des[0]==des[4])
				return VALEUR_YAM;
			else return 0;
			
		case CHANCE:
		
			/* Somme des ds */
			return (des[0]+des[1]+des[2]+des[3]+des[4]);

		default:
			return 0;	
	}

}
