// C Source File
// Created 01/09/2001; 17:55:38


#include "definit.h"
#include "fctgraf.h"
#include "graphic.h"
#include "calculs.h"

short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File

void lance(struct Yam *jeux)
{
	
	unsigned int nbjoueurs=jeux->nbjoueurs;

	int score[nbjoueurs][NBLIGNES];
	short des[5];
	
	int MAX_COUPS;
	
	int curcoup;	/* On ne peut jouer que 3 fois */
	
	int nbcoups=13;
	
	unsigned short fin;
	
	size_t curjoueur=1; /* le joueur 1 commence  jouer */
	size_t i,j;
	
	short touche;
	
	/* Dfinit le nombre de fois que l'on lance le ds */
	if(jeux->type==DIRECT)
		MAX_COUPS=1;
	else
		MAX_COUPS=3;	
	
	/* initialisation du tableau score*/
	for(i=0;i<NBLIGNES;i++)
	{
		for(j=0;j<nbjoueurs;j++)
		{
			if (i==ptTOTAL || i==BONUS || i==TOTAL)
			{
				score[j][i]=0;
			}
			else
			{
				score[j][i]=-1; /* -1 et pas 0 pour diffrencier le score nul du coup non jou */
			}
		}
	}
			
	
	ClrScr();

	randomize(); /* Prpare le gnrateur de nb alatoires */
	
	affich_entete(); /* Affiche le titre : YAM89C */
	
	affich_table(); /* Affiche les tableaux */
	affich_tab_des();
	affich_noms(jeux);
	
coup_suivant:

	curcoup=1;
	
	affich_score(score[curjoueur-1]);
	
	/* Affiche en surbrillance le joueur en cour */
	if (nbjoueurs!=1)
		zone(COL_NOMS,(curjoueur-1)*2*INTER_NOMS+LIGNE_NOMS,DrawStrWidth(jeux->noms[curjoueur-1],0)+COL_NOMS,(curjoueur-1)*2*INTER_NOMS+LIGNE_NOMS+5,A_XOR);
	
	/*Affiche en surbrillance le coup  jouer si en mode crois */
	if (jeux->type==CROISE)
	{
	
		for(i=0 , j=CHANCE ; ; i++ , j--)
		{
			
			if (score[curjoueur-1][i]==-1)
			{
				zone(COLT0+1,i*HAUTEUR_LIGNE+HAUT+1,COLT1-1,i*HAUTEUR_LIGNE+HAUT+HAUTEUR_LIGNE-1,A_XOR);
				break;
			}
			if (score[curjoueur-1][j]==-1)
			{
		  	zone(COLT2+1,(j-8)*HAUTEUR_LIGNE+HAUT+1,COLT3-1,(j-8)*HAUTEUR_LIGNE+HAUT+HAUTEUR_LIGNE-1,A_XOR);
				break;
			}
			
		}
					
	}
	
	for(i=0;i<5;i++)
		des[i]=random(6)+1; /* nombre alatoire entre 1 et 6 compris */
		
	affich_des(des);
	
	do
	{
		
		
		{
			char buffer[2];
			
			sprintf(buffer,"%d",MAX_COUPS-curcoup);
			DrawStr(LARGEUR-6,HAUTEUR-6,buffer,A_REPLACE);			
			
		}

		
		touche=ngetchx();
		fin=0;
		
		switch (touche)
		{
			
			case '1' ... '5': /* Si l'on appuie sur une touche entre 1 et 5 */
	
				i=touche-'0'; /* convertit touche en int ('0' devient 0, '1' devient 1...) */
				zone(COLD0+1,ligne_des(i)+1,COLD1-1,ligne_des(i)+9,A_XOR);
				
				des[i-1]=-des[i-1]; /* On prend l'oppos pour se souvenir */
				
				break;
				
			case KEY_APPS: /* affiche un popup de slection du coup  jouer */
			{
				
				unsigned short rtnValue;
				
				if (jeux->type==CROISE)
				{
	
					for(i=0 , j=CHANCE ; ; i++ , j--)
					{
						
						if (score[curjoueur-1][i]==-1)
						{
							zone(COLT0+1,i*HAUTEUR_LIGNE+HAUT+1,COLT1-1,i*HAUTEUR_LIGNE+HAUT+HAUTEUR_LIGNE-1,A_XOR);
							rtnValue=i+1;
							break;
						}
						if (score[curjoueur-1][j]==-1)
						{
							zone(COLT2+1,(j-8)*HAUTEUR_LIGNE+HAUT+1,COLT3-1,(j-8)*HAUTEUR_LIGNE+HAUT+HAUTEUR_LIGNE-1,A_XOR);
							rtnValue=j+1;
							break;
						}
						
					}
					
				}
				else
					rtnValue=affich_popup(score[curjoueur-1]);
				
				if (rtnValue==0)
					break;
					
				rtnValue--; /* rtnValue correspond maintenant aux lignes dans score */
				
				fin=1; /* Quitte la boucle aprs avoir fini ce traitement */
				
				for(i=0;i<5;i++)
					des[i]=abs(des[i]); /* On enlve les signes '-' des valeurs des ds (voir ci-dessus quand on prend l'oppos) */
				

				i=calcul_points(des,rtnValue);

		
				/* Si le joueur n'a pas relanc ses ds, il double ses points */
				/* cela ne marche qu'avec : BRELAN, FULL, les 2 suites, CARRE et YAM */
				
				if (curcoup==1 && rtnValue>=BRELAN && rtnValue<=YAM)
					i=2*i;
				
				score[curjoueur-1][rtnValue]=i;

				calcul_totaux(score[curjoueur-1]);
				affich_score(score[curjoueur-1]);
				
				{
					char strTotal[5];
					sprintf(strTotal,"%d",score[curjoueur-1][TOTAL]);
					DrawStr(COL_NOMS,(curjoueur-1)*2*INTER_NOMS+LIGNE_NOMS+INTER_NOMS,"                  ",A_REPLACE);					
					DrawStr(COL_NOMS,(curjoueur-1)*2*INTER_NOMS+LIGNE_NOMS+INTER_NOMS,strTotal,A_REPLACE);					
				}

				
				if(nbjoueurs!=1)
					attend(1); /* attend 1 seconde avant de passer au joueur suivant pour laisser afficher les scores */
				
				break;	
				
			}
				
			case KEY_ENTER:
			{
				unsigned short trouve;
				
				if(curcoup>=MAX_COUPS) break;
				
				trouve=0;
				for(i=0;i<5;i++)
				{
					if(des[i]<0)
					{
						if (trouve==0) curcoup++;
				
						trouve=1;
						des[i]=random(6)+1; /* nombre alatoire entre 1 et 6 compris*/
					}
				}
				if (trouve==0)
					break;
						
				affich_des(des);	
							
				break;
			}	

			case KEY_ESC:
			
				quit();
				break;
				
			case KEY_F1: /* Affiche tableau joueur 1 */
			
				encour(1);
				break;
	
			case KEY_F2: /* Affiche tableau joueur 1 */
			
				encour(2);
				break;

			case KEY_F3: /* Affiche tableau joueur 1 */
			
				encour(3);
				break;
			
			case KEY_F4: /* Affiche tableau joueur 1 */

				encour(4);
				break;
					
			case KEY_MODE:
			
				affich_aide();
				break;
		}
	
	}while(!fin);
	
	
	/* Affiche en surbrillance le joueur en cour */
	if (nbjoueurs!=1)
		zone(COL_NOMS,(curjoueur-1)*2*INTER_NOMS+LIGNE_NOMS,DrawStrWidth(jeux->noms[curjoueur-1],0)+COL_NOMS,(curjoueur-1)*2*INTER_NOMS+LIGNE_NOMS+5,A_XOR);

	joueursuivant;

	if(curjoueur==1)
	{
		
		/* Le compteur nbcoups permet de savoir quand la partie est finie */
		/* Il est initialis  13 et est dcrment chaque fois que le dernier joueur joue */
		nbcoups--;
		if (nbcoups==0) /* quand il est nul c'est que la partie est finie */
		{
			
			for(i=0, j=0;i<nbjoueurs;i++)
			{
		
				if((int)j<score[i][TOTAL])
				{
					j=score[i][TOTAL];
					curjoueur=i;
				}	
		
			}
			
			clrscr();
			printf("Meilleur joueur : %s\n avec %d points.",jeux->noms[curjoueur],(int)j);
			quit();
			
		}
		
	}
		
	goto coup_suivant; /* Oui je sais. Ce n'est pas trs lgant mais tellement plus comprhensible */
	
}

// Main Function
void _main()
{
	
	struct Yam jeux;
		
	clrscr();
	
	presentation(); /* Affiche l'cran de prsentation */
	
	menu(&jeux); /* Affiche le menu */
	
	lance(&jeux); /* commence la partie */
	
	
	quit();
	
}
